-- Deploy numerus:available_invoice_status to pg
-- requires: schema_numerus
-- requires: invoice_status
-- requires: invoice_status_i18n

begin;

set search_path to numerus;

insert into invoice_status (invoice_status, name)
values ('created', 'Created')
     , ('sent', 'Sent')
     , ('partial', 'Partial')
     , ('paid', 'Paid')
     , ('unpaid', 'Unpaid')
on conflict (invoice_status) do nothing
;

insert into invoice_status_i18n (invoice_status, lang_tag, name)
values ('created', 'ca', 'Creada')
     , ('sent', 'ca', 'Enviada')
     , ('partial', 'ca', 'Parcial')
     , ('paid', 'ca', 'Cobrada')
     , ('unpaid', 'ca', 'No cobrada')
     , ('created', 'es', 'Creada')
     , ('sent', 'es', 'Enviada')
     , ('partial', 'es', 'Parcial')
     , ('paid', 'es', 'Cobrada')
     , ('unpaid', 'es', 'No cobrada')
on conflict (invoice_status, lang_tag) do nothing
;

update invoice set invoice_status = 'created' where invoice_status in ('sent', 'unpaid');
delete from invoice_status_i18n where invoice_status in ('sent', 'unpaid');
delete from invoice_status where invoice_status in ('sent', 'unpaid');

commit;
